(* Copyright (C) 2014
   Patryk Czarnik  <czarnik@mimuw.edu.pl>
   Jacek Chrząszcz <chrzaszcz@mimuw.edu.pl>
   Aleksy Schubert <alx@mimuw.edu.pl>
*)
(* Require Import Semantics.
Require Import ArithOps.

Require Import ZArith.

Module Type Tactics.

Declare Module SEM : SEMANTICS.

Module AllStr := SEM.M_AllStructures.
Module P := AllStr.M_Program.
Module PS := P.M_ProgramStructures.
Module VAT := PS.M_ValuesAndTypes.
Module RS := AllStr.M_RuntimeStructures.
Module ARS := AllStr.M_Arithmetics.

Section Aritmetic.

Import VAT.
*)
(*  @author Patryk Czarnik *)

(** Tries to prove [M_Numeric_Int.range x] for a concrete [x] value. *)
Ltac prove_range_int :=
  unfold M_Numeric_Int.range;
  unfold M_Numeric_Int.half_base;
  unfold M_Numeric_Int.power;
  simpl;
  try (unfold Z.pow_pos; simpl);
  split; omega.

Ltac injection_list :=
  match goal with
  | Heq: (_::_) = (_::_) |- _ =>
    injection Heq; clear Heq; intros; subst
  | _ => idtac
  end.
